#if ! defined(__LS_H)
#define __LS_H

/*--------------------  Basic type definitions -----------------------*/

#include "cb.h"

/* ----------------------------------------------------------------- */

void SetLSParameters(int QuietLevel,
                     int SwappingMethod,
                     int GLAIterations,
                     int LSIterations,
                     int MinBookSize,
					 int MaxBookSize,
                     ERRORFTYPE errorf);

int IterateByLocalSearch(TRAININGSET*	TS,
						 CODEBOOK*	CB,
						 PARTITIONING* P,
						 YESNO 	ImproveExisting,
						 double*	FinalError,
						 int EvaluationFunction,
						 int MovingMethod);

int BruteForce(TRAININGSET* TSIn, 
			   CODEBOOK* CBOut, 
			   PARTITIONING* PAOut, 
			   int EvaluationFunction, 
			   int Minimum, 
			   int Maximum,
			   int QuietLevel, 
			   int SwappingMethod, 
			   int GLAIterations, 
			   int LSIterations,
			   int OutputGraphData,
			   int InitialSolution,
			   int MovingMethod);

int Stepwise(TRAININGSET* TSIn, 
			 CODEBOOK* CBOut, 
			 PARTITIONING* PAOut, 
			 int EvaluationFunction, 
			 int Minimum, 
			 int Maximum,
			 int QuietLevel, 
			 int SwappingMethod, 
			 int GLAIterations, 
			 int LSIterations,
			 int LSStepwiseIterations,
			 int OutputGraphData,
			 int InitialSolution,
			 int SearchDirectionDecreasing,
			 int MovingMethod);

/* ----------------------------------------------------------------- */

#endif /* __LS_H */
