#ifndef IDXQUEUE_H
#define IDXQUEUE_H

typedef struct {
	struct IDXQUEUEELEMENT* Prev;
	struct IDXQUEUEELEMENT* Next;
	void* Data;
} IDXQUEUEELEMENT;

typedef struct {
	IDXQUEUEELEMENT* Head;
	IDXQUEUEELEMENT* Tail;
	int Count;
} INDEXEDQUEUE;

extern void InitIndexedQueue(INDEXEDQUEUE* IQ);
extern void DeleteIndexedQueue(INDEXEDQUEUE* IQ);
extern void EnqueueIntoIndexedQueue(INDEXEDQUEUE* IQ, void* Item);
extern int NumberOfItemsInIndexedQueue(INDEXEDQUEUE* IQ);
extern void* IndexedQueueItem(INDEXEDQUEUE* IQ, int Index, int Remove);
#define DequeueFromIndexedQueue(IQ) IndexedQueueItem((IQ), 0, 1)
#define RemoveFromIndexedQueue(IQ, Index) IndexedQueueItem((IQ), (Index), 1)

#define ItemInIndexedQueue(IQ, Index) IndexedQueueItem((IQ), (Index), 0)

#endif
