
/********************************************************************

	swi_Application.c

	Ismo Krkkinen

	Last changed 12.11.1999

	Maintains general information about the running program needed by
	other modules to work correctly with Windows.

********************************************************************/

#include "swi_Application.h"
#include "memctrl.h"

static HWND ParentHandle = 0;
static HWND WindowHandle = 0;
static char* ProgramTitle = 0;
static char* ProgramInfo = 0;
static char* Helpfile = 0;
static char InternalInfo[] = "\nSWI version 0.07\n"
			"\nCopyright 1999, 2007 Joensuun Yliopisto,\n"
			"Tietojenksittelytieteen laitos";
static HICON AppIcon = 0;

HWND swiParentWindowHandle() {
	return ParentHandle;
}

HWND swiMainWindowHandle() {
	return WindowHandle;
}

char* swiApplicationTitle() {
	return ProgramTitle;
}

char* swiApplicationInfo() {
	return ProgramInfo;
}

char* swiInternalInfo() {
	return InternalInfo;
}

char* swiHelpFilename() {
	return Helpfile;
}

void swiInitializeParentWindowHandle(HWND ParentWindowHandle) {
	ParentHandle = ParentWindowHandle;
}

void swiInitializeMainWindowHandle(HWND MainWindowHandle) {
	WindowHandle = MainWindowHandle;
}

void swiSetAppIcon(HICON Icon) {
	AppIcon = Icon;
}

HICON swiAppIcon() {
	return AppIcon;
}

static HIMAGELIST LargeList = 0;
static HIMAGELIST SmallList = 0;

void swiInitializeImageLists(HIMAGELIST Large, HIMAGELIST Small) {
	LargeList = Large;
	SmallList = Small;
}

HIMAGELIST swiLargeImageList() {
	return LargeList;
}

HIMAGELIST swiSmallImageList() {
	return SmallList;
}

int swiInitializeApplicationData(char* ApplicationTitle,
	char* ApplicationInfo, char* HelpFilename)
{
	if (ApplicationTitle) {
		if (ProgramTitle) deallocate(ProgramTitle);
		ProgramTitle = allocate(strlen(ApplicationTitle) + 1);
		strcpy(ProgramTitle, ApplicationTitle);
		if (ProgramInfo) deallocate(ProgramInfo);
		if (Helpfile) deallocate(Helpfile);
		if (HelpFilename) {
			Helpfile = allocate(strlen(HelpFilename) + 1);
			strcpy(Helpfile, HelpFilename);
		} else Helpfile = 0;
		if (ApplicationInfo) {
			ProgramInfo = allocate(strlen(ApplicationInfo) + 1);
			strcpy(ProgramInfo, ApplicationInfo);
		} else ProgramInfo = 0;
		return 1;
	} else return 0;
}

void swiClearApplicationData() {
	if (ProgramTitle) deallocate(ProgramTitle);
	ProgramTitle = 0;
	if (ProgramInfo) deallocate(ProgramInfo);
	ProgramInfo = 0;
	WindowHandle = 0;
}

int swiMessageLoopEntered() {
	return WindowHandle != 0;
}
