#ifndef SWI_DATACLASS_H
#define SWI_DATACLASS_H

#include "swi_Storage.h"
#include "swi_Internal.h"
#include <windows.h>

/* data class functions */
extern void swiDCDelete(SWI_ID DataClassID);
extern int swiDCExists(SWI_ID DataClassID);

extern int swiDCIcon(SWI_ID DataClassID);
extern SWI_ID swiDCFilter(SWI_ID DataClassID);
extern int swiDCSaveOnExit(SWI_ID DataClassID);
extern int swiDCSimultaneousViews(SWI_ID DataClassID);
extern SWI_ID swiDCRequirement(SWI_ID DataClassID);
extern char* swiDCDescription(SWI_ID DataClassID);
extern SWI_ID swiDCViewParameters(SWI_ID DataClassID);

/* data set functions */
extern int swiDSIcon(SWI_ID DataID);
extern void swiDSDelete(SWI_ID DataID);
extern HWND swiDSWindowHandle(SWI_ID DataID);
extern int swiDSCreateTextWindow(SWI_ID DataID);
extern void swiDSTextWindowClosed(SWI_ID DataID);

extern void swiDSChanged(SWI_ID DataID);
extern int swiDSHasChanged(SWI_ID DataID);
extern int swiDSHasBeenSaved(SWI_ID DataID);
extern SWI_ID swiDSGetClassID(SWI_ID DataID);
extern char* swiDSName(SWI_ID DataID);
extern void swiDSSetName(SWI_ID DataID, char* NewName);
extern void swiDSSetExternal(SWI_ID DataID, void* NewExternal);

extern void swiDSUnlock(SWI_ID DataID);
extern void swiDSLock(SWI_ID DataID);
extern int swiDSLocked(SWI_ID DataID);

/* user defined function existence checks */
extern int swiDCLoadDefined(SWI_ID DataClassID);
extern int swiDCSaveDefined(SWI_ID DataClassID);
extern int swiDCDestroyDefined(SWI_ID DataClassID);
extern int swiDCTextViewDefined(SWI_ID DataClassID);

/* user defined function wrappers */
extern void swiDSLoad(SWI_ID ClassID, char* Filename);
extern int swiDSSave(SWI_ID DataID, char* Filename);
extern int swiDSDestroy(SWI_ID DataID);
extern int swiDSLineCount(SWI_ID DataID, int* ApproximateMaxLineLength);
extern char* swiDSLine(SWI_ID DataID, int LineNumber);

#endif
