/********************************************************************

	swi_Enumerated.c

	Ismo Krkkinen

	Last changed 12.11.1999

********************************************************************/

#include "swi_Enumerated.h"
#include "swi_EnumeratedSymbols.h"
#include <windows.h>
#include "swi_ProcessAndOptions.h"
#include "swi_Parameters.h"

static int OriginalValue;
static int OptionNumber;

BOOL APIENTRY EnumeratedDialogProcedure(HWND Handle, UINT Message,
	WPARAM wParam, LPARAM lParam)
{
	HWND ddl;
	int k, n;
	switch (Message) {
	case WM_INITDIALOG:
		SetDlgItemText(Handle, SWI_ENUMERATED_STATIC,
			swiFPSGetDocumentString(OptionNumber));
		ddl = GetDlgItem(Handle, SWI_ENUMERATED_DROPDOWNLIST);
		for (k = swiFPSGetMinValue(OptionNumber);
			k <= swiFPSGetMaxValue(OptionNumber); k++)
		{
			n = SendMessage(ddl, CB_ADDSTRING, 0,
				(int)swiFPSGetEnumValueName(OptionNumber, k));
			SendMessage(ddl, CB_SETITEMDATA, n, k);
		}
		SendMessage(ddl, CB_SETCURSEL, 0, 0);
		return TRUE;
	case WM_COMMAND:
		if (HIWORD(wParam) == BN_CLICKED) {
			if (LOWORD(wParam) == IDOK) {
				ddl = GetDlgItem(Handle, SWI_ENUMERATED_DROPDOWNLIST);
				n = SendMessage(ddl, CB_GETCURSEL, 0, 0);
				k = SendMessage(ddl, CB_GETITEMDATA, n, 0);
				EndDialog(Handle, k);
				return TRUE;
			} else if (LOWORD(wParam) == IDCANCEL) {
				EndDialog(Handle, OriginalValue);
				return TRUE;
			}
		}
		break;
	}
	return FALSE;
}

int swiGetEnumeratedValue(int Option, int OldValue, HWND Parent) {
	OptionNumber = Option;
	OriginalValue = OldValue;
	return DialogBox(GetModuleHandle(0), "swiDialogEnumerated",
		Parent, &EnumeratedDialogProcedure);
}
