/********************************************************************

	swi_Integer.c

	Ismo Krkkinen

	Last changed 12.11.1999

********************************************************************/


#include "swi_Integer.h"
#include "swi_IntegerSymbols.h"
#include <windows.h>
#include "swi_ProcessAndOptions.h"
#include "swi_Parameters.h"
#include "interfc.h"

static int OriginalValue;
static char* Description;
static int OptionIndex;

BOOL APIENTRY IntegerDialogProcedure(HWND Handle, UINT Message,
	WPARAM wParam, LPARAM lParam)
{
	char Number[16];
	int Result;
	switch (Message) {
	case WM_INITDIALOG:
		SetDlgItemText(Handle, SWI_INTEGER_STATIC, Description);
		itoa(OriginalValue, Number, 10);
		SetDlgItemText(Handle, SWI_INTEGER_EDIT, Number);
		return TRUE;
	case WM_COMMAND:
		if (HIWORD(wParam) == BN_CLICKED) {
			if (LOWORD(wParam) == IDOK) {
				GetDlgItemText(Handle, SWI_INTEGER_EDIT, Number, 15);
				Result = atoi(Number);
				if (Result < swiFPSGetMinValue(OptionIndex))
					ErrorMessage("Minimum allowed value is %i.\n",
						swiFPSGetMinValue(OptionIndex));
				else if (Result > swiFPSGetMaxValue(OptionIndex))
					ErrorMessage("Maximum allowed value is %i.\n",
						swiFPSGetMaxValue(OptionIndex));
				else EndDialog(Handle, Result);
				return TRUE;
			} else if (LOWORD(wParam) == IDCANCEL) {
				EndDialog(Handle, OriginalValue);
				return TRUE;
			}
		}
		break;
	}
	return FALSE;
}

int swiGetIntegerValue(int Option, int OldValue, HWND Parent) {
	Description = swiFPSGetDocumentString(Option);
	OriginalValue = OldValue;
	OptionIndex = Option;
	return DialogBox(GetModuleHandle(0), "swiDialogInteger",
		Parent, &IntegerDialogProcedure);
}
