/********************************************************************

	swi_Internal.c

	Ismo Krkkinen

	Last changed 12.11.1999

	Initialization and finalization routines.

********************************************************************/

#include "swi_Internal.h"
#include <string.h>
#include "memctrl.h"
#include "swi_WindowsAccelerator.h"
#include "swi_MainMenuSymbols.h"
#include "swi_WindowsControls.h"
#include "swi_SelectedData.h"
#include "swi_ImageView.h"
#include "swi_Filter.h"
#include "swi_DragAndDrop.h"
#include "swi_Storage.h"
#include "swi_Process.h"
#include "resource.h"

void swiInitialize() {
	swiSInitialize();
	swiFLInitialize();
	swiInitializeProcess();
	swiWAInitialize();
	swiWCInitialize();
	swiSDInitialize();
	swiIVInitialize();
	swiDDInitialize();
	/* make standard accelerators used in menus */
	swiWAAdd('A', 1, 1, 0, 0, SWI_MAINMENU_FILE_SAVEAS);
	swiWAAdd('I', 1, 1, 0, 0, SWI_MAINMENU_VIEW_IMAGE);
    swiWAAdd('O', 1, 1, 0, 0, SWI_MAINMENU_FILE_OPEN);
    swiWAAdd('Q', 1, 1, 0, 0, SWI_MAINMENU_PROCESS_QUEUE);
    swiWAAdd('S', 1, 1, 0, 0, SWI_MAINMENU_FILE_SAVE);
    swiWAAdd('T', 1, 1, 0, 0, SWI_MAINMENU_VIEW_TEXT);
	swiWAAdd('C', 1, 1, 0, 0, SWI_MAINMENU_FILE_CLOSE);
}

void swiFinalize() {
	swiWCFinalize();
	swiWAFinalize();
	swiSFinalize();
}

char* AppendString(char* Begin, char* End) {
	char* NewString;
	int Length;
	if (Begin) Length = strlen(Begin);
	else Length = 0;
	if (End) Length += strlen(End);
	NewString = allocate(Length + 1);
	NewString[0] = 0;
	if (Begin) strcpy(NewString, Begin);
	if (End) strcat(NewString, End);
	return NewString;
}

char* swiFilename(char* FullFilename) {
	char* Last = strrchr(FullFilename, '\\');
	if (Last) return Last + 1;
	return FullFilename;
}

SWI_ID swiBestFittingProcessClass(SWI_ID Original, int Source) {
	SWI_ID CurrentID;
	CurrentID = Original;
	while (CurrentID 
		&& !swiSDSimilarContents(Source, swiPCInputRequirement(CurrentID)))
	{
		CurrentID = swiPCLinked(CurrentID);
		if (CurrentID == Original) return Original; /* loop? */
	}
	return CurrentID ? CurrentID : Original;
}

int swiExtension(char* Filename, char* Extension) {
	char* End;
	int length;
	if (!Filename) return 0;
	if (!Extension) return 1;
	length = strlen(Extension);
	if ((int)strlen(Filename) <= length) return 0;
	End = Filename + length;
	if (*(End - 1) != '.') return 0;
	return !strnicmp(End, Extension, length);
}
