/***************************************************

	swi_Messages.h

	Ismo Krkkinen

	Last modified 12.11.1999

	Defines all message identifiers used for internal communication.

***************************************************/

#ifndef SWI_MESSAGES_H
#define SWI_MESSAGES_H

#include <windows.h>

enum {
	/* tells that thread has finished, wParam is the return value */
	SWI_WM_THREAD_FINISHED = WM_USER,
	/* tells main window to check for new processes to start */
	SWI_WM_CHECK_NEW_PROCESSES,
	/* tells process queue window to update it's contents */
	SWI_WM_UPDATE_PROCESS_LISTS,
	/* tells parent window to hide all it's children, sent by main window */
	SWI_WM_CHILD_WINDOW_VISIBILITY,
	/* tells ProcessAndOptions-dialog to select process class given as wParam */
	SWI_WM_SELECT_PROCESS_CLASS,
	/* tells output window to add a string, wParam is OutputFlow*, lParam is char* */
	SWI_WM_ADD_STRING,
	/* notifies data set window of change in status, if wParam, then enabled */
	SWI_WM_ENABLED,
	/* tells main window to add a new data set, if wParam, then to output list view,
		otherwise to main list view, lParam is the SWI_ID of the data set */
	SWI_WM_NEW_DATASET,
	/* tells view to update it's title bar or icon to change text. 
		lParam is ID, if necessary */
	SWI_WM_RENAMED,
	/* adds new window name to the Window-menu, lParam is the handle of the window */
	SWI_WM_ADD_TO_WINDOW_MENU,
	/* removes window name from the Window-menu, lParam is the handle of the window */
	SWI_WM_REMOVE_FROM_WINDOW_MENU,
	/* sets the image area size in image view window. wParam is width, lParam is height */
	SWI_WM_SET_IMAGE_SIZE,
	/* note: these two below must be consecutive enumerants */
	/* tells to try to add data set to a view, wParam is the ID, 
	lParam is parameter ID, if we are copying view contents */
	SWI_WM_ADD_TO_VIEW,
	/* tells to remove from the view, lParam is the ID */
	SWI_WM_REMOVE_FROM_VIEW,
	/* note: these two above must be consecutive enumerants */
	/* wParam is the ID, lParam is the parameter set to copy */
	SWI_WM_IV_COPY_PARAMETERS,
	/* tells image view window to call special update function */
	SWI_WM_IV_UPDATE_SPECIAL,
	/* tells image view window to replace the special drawing commands,
	wParam is the new set */
	SWI_WM_IV_NEW_SPECIAL,
	/* sorts image window list view */
	SWI_WM_IV_SORT,
	/* closes selected files in the active area of the main window */
	SWI_WM_CLOSE_SELECTED
};

#endif
