/********************************************************************

	swi_OwnedWindow.c

	Ismo Krkkinen

	Last changed 12.11.1999

********************************************************************/


#include "swi_OwnedWindow.h"
#include "swi_Storage.h"
#include "memctrl.h"

typedef struct {
	SWI_ID ID;
	SWIDataTypes Type;
	HWND Handle;
	int Visible, HiddenWhenMinimized;
} OwnedWindow;

SWI_ID swiOWNew(HWND Handle) {
	OwnedWindow* OW;
	if (Handle) {
		OW = allocate(sizeof(OwnedWindow));
		OW->Type = OWNED_WINDOW;
		OW->Handle = Handle;
		OW->Visible = 0;
		OW->HiddenWhenMinimized = 0;
		swiSInsert(OW);
		return OW->ID;
	}
	return 0;
}

void swiOWDelete(SWI_ID OwnedWindowID) {
	OwnedWindow* OW = swiSRemove(OwnedWindowID, OWNED_WINDOW);
	if (OW) deallocate(OW);
}

void swiOWShow(SWI_ID OwnedWindowID) {
	OwnedWindow* OW = swiSFind(OwnedWindowID, OWNED_WINDOW);
	if (OW && OW->HiddenWhenMinimized) {
		ShowWindow(OW->Handle, SW_SHOW);
		OW->HiddenWhenMinimized = 0;
	}
}

void swiOWHide(SWI_ID OwnedWindowID) {
	OwnedWindow* OW = swiSFind(OwnedWindowID, OWNED_WINDOW);
	if (OW && OW->Visible) {
		ShowWindow(OW->Handle, SW_HIDE);
		OW->HiddenWhenMinimized = 1;
	}
}

void swiOWSelfShow(SWI_ID OwnedWindowID) {
	OwnedWindow* OW = swiSFind(OwnedWindowID, OWNED_WINDOW);
	if (OW) OW->Visible = 1;
}

void swiOWSelfHide(SWI_ID OwnedWindowID) {
	OwnedWindow* OW = swiSFind(OwnedWindowID, OWNED_WINDOW);
	if (OW) OW->Visible = 0;
}
