#ifndef SWI_PROCESS_H
#define SWI_PROCESS_H

#include "swi_Internal.h"
#define SWI_FIRST_PROCESS_MENUITEM 30000
#define SWI_LAST_PROCESS_MENUITEM 32000

typedef enum {
	SWI_OVERWRITE_NEVER = 0,
	SWI_OVERWRITE_ASK_USER,
	SWI_OVERWRITE_ALWAYS
} swiOverwriteValues;

extern unsigned long ThreadHandle;

extern void swiInitializeProcess();

extern int swiEnqueueProcess(SWI_ID ProcessID);
extern void swiDequeueProcess(SWI_ID ProcessID);
extern void swiRemoveFromProcessQueue(int QueueSlot);
extern int swiQueueSlots();
extern SWI_ID swiQueueContents(int QueueSlot);
extern int swiQueueEmpty();

extern int swiRunQueuedProcess();
extern int swiFinishQueuedProcess();
extern void swiHaltCurrentProcess();
extern int swiCurrentProcessCanBeHalted();
extern int swiLastReturnValue();
extern SWI_ID swiRunningProcess();

extern int swiProcessExitRequested();

extern void swiKillCurrentProcess();

extern void swiPTDelete(SWI_ID ProcessTypeID);
extern SWI_ID swiPTParent(SWI_ID ProcessTypeID);
extern char* swiPTDescription(SWI_ID ProcessTypeID);


extern void swiPCDelete(SWI_ID ProcessClassID);
extern int swiPCExists(SWI_ID ProcessClassID);
extern SWI_ID swiPCProcessType(SWI_ID ProcessClassID);
extern SWI_ID swiPCParameterSet(SWI_ID ProcessClassID);
extern SWI_ID swiPCWorkingParameterSet(SWI_ID ProcessClassID);
extern void swiPCParameterSetToWorking(SWI_ID ProcessClassID);
extern void swiPCWorkingToParameterSet(SWI_ID ProcessClassID);
extern char* swiPCDescription(SWI_ID ProcessClassID);
extern char* swiPCPreconditionDescription(SWI_ID ProcessClassID);
extern SWI_ID swiPCInputRequirement(SWI_ID ProcessClassID);
extern SWI_ID swiPCOutputRequirement(SWI_ID ProcessClassID);
extern int swiPCOverwriteOutput(SWI_ID ProcessClassID);
extern SWI_ID swiPCLinked(SWI_ID ProcessClassID);

extern int swiPCIsMenuItem(SWI_ID ProcessClassID);
extern int swiPCHasAccelerator(SWI_ID ProcessClassID);
extern int swiPCUsesCtrl(SWI_ID ProcessClassID);
extern int swiPCUsesAlt(SWI_ID ProcessClassID);
extern int swiPCUsesShift(SWI_ID ProcessClassID);
extern int swiPCUsesVirtual(SWI_ID ProcessClassID);
extern int swiPCUsesKey(SWI_ID ProcessClassID);
extern int swiPCUsesCommand(SWI_ID ProcessClassID);

extern SWI_ID swiPRNew(SWI_ID ProcessClassID, int OutputOverwritesExisting);
extern void swiPRDelete(SWI_ID ProcessID);
extern int swiPRRun(SWI_ID ProcessID);
extern int swiPRFinish(SWI_ID ProcessID);
extern int swiPRRunning(SWI_ID ProcessID);
extern int swiPRDataSetCount(SWI_ID ProcessID);
extern SWI_ID swiPRDataSet(SWI_ID ProcessID, int DataSetIndex);
extern SWI_ID swiPRParameterSet(SWI_ID ProcessID);
extern SWI_ID swiPRClass(SWI_ID ProcessID);
extern void swiPRExitValue(SWI_ID ProcessID, int ReturnValue);

#endif
