/********************************************************************

	swi_WindowsAccelerator.c

	Ismo Krkkinen

	Last changed 12.11.1999

********************************************************************/


#include "swi_WindowsAccelerator.h"


void MakeAccelerator(ACCEL* A, 
	int Key, int Special, int Ctrl, int Alt, int Shift, int Command)
{
	A->fVirt = FNOINVERT | (Ctrl ? FCONTROL : 0) | (Alt ? FALT : 0) 
		| (Shift ? FSHIFT : 0) | (Special ? FVIRTKEY : 0);
	A->key = Key;
	A->cmd = Command;
}

#define SWI_ACCELERATOR_MAXCOUNT 1024
static int Count = 0;
static ACCEL Table[SWI_ACCELERATOR_MAXCOUNT];
static HACCEL Handle = 0;

int swiWAAdd(int Key, int Special, 
	int Ctrl, int Alt, int Shift, int Command)
{
	int k;
	ACCEL A;
	if (Count >= SWI_ACCELERATOR_MAXCOUNT) return 0;
	MakeAccelerator(&A, Key, Special, Ctrl, Alt, Shift, Command);
	for (k = 0; k < Count; k++) {
		if ((A.key == Table[k].key) && (A.fVirt == Table[k].fVirt))
			return 0;
		if (A.cmd == Table[k].cmd) return 0;
	}
	Table[Count].fVirt = A.fVirt;
	Table[Count].key = A.key;
	Table[Count].cmd = A.cmd;
	Count++;
	return Count;
}

void swiWAInitialize() {
	Count = 0;
	Handle = 0;
}

HACCEL swiWACreate() {
	Handle = CreateAcceleratorTable(Table, Count);
	return Handle;
}

void swiWAFinalize() {
	if (Handle) DestroyAcceleratorTable(Handle);
	Handle = 0;
	Count = 0;
}
