#ifndef SWI_WINDOWSCONTROLS_H
#define SWI_WINDOWSCONTROLS_H

#include "swi_Internal.h"

extern void swiWCInitialize();
extern void swiWCFinalize();

/* list box functions */

extern int swiLBAdd(HWND ListBoxHandle, char* Text, SWI_ID Tag);
extern int swiLBCount(HWND ListBoxHandle);
extern void swiLBRemove(HWND ListBoxHandle, int Index);
extern void swiLBRemoveAll(HWND ListBoxHandle);

extern void swiLBSetFocusIndex(HWND ListBoxHandle, int Index);
extern int swiLBFocusIndex(HWND ListBoxHandle);
extern SWI_ID swiLBTag(HWND ListBoxHandle, int Index);

extern void swiLBSelectSingle(HWND ListBoxHandle, int Index);
extern int swiLBSelectedCount(HWND ListBoxHandle);
extern int swiLBSelectedIndices(HWND ListBoxHandle, int** Buffer);

/* combo box functions */

extern int swiCBAdd(HWND ComboBoxHandle, char* Text, SWI_ID Tag);
extern int swiCBCount(HWND ComboBoxHandle);
extern void swiCBRemoveAll(HWND ComboBoxHandle);

extern void swiCBSetSelectedIndex(HWND ComboBoxHandle, int Index);
extern int swiCBSelectedIndex(HWND ComboBoxHandle);
extern SWI_ID swiCBTag(HWND ComboBoxHandle, int Index);

/* scroll bar functions */

extern int swiSBMove(HWND ScrollBarHandle, int Bar, int ScrollCode,
	int LineOffset, int PageOffset, int ThumbPosition);
extern int swiSBSize(HWND ScrollBarHandle, int Bar, int Minimum, int Maximum, int Page);
extern int swiSBPosition(HWND ScrollBarHandle, int Bar);

#endif
